#include	"init.h"			// InitApp(),InitInst()
#include	<math.h>		      			// sin()      
  
void		MdelSet(HWND, double, double, double, double);
void		NeMo(HDC, int, int, int, int);
//***************************************************************
int PASCAL WinMain(HINSTANCE hInstance,	HINSTANCE hPrevInstance, 
				   LPSTR	 lpCmdLine,	int		  nCmdShow     )
{	MSG	msg;  

	InitApp( hInstance, "MANDEL");			
	InitInst(hInstance, nCmdShow, "MANDEL", "Ʈ(BDM)");

	// ޽ Ͽ WndProc() 	
	while (GetMessage(&msg, NULL, 0, 0))  
	{
		TranslateMessage(&msg);				// Űڵ ȯ
		DispatchMessage(&msg);				// ޽ 
	}
	return (msg.wParam); 
}
//**************************************************************
LRESULT WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC				hDC;
	PAINTSTRUCT		ps;
	static			cpok, cnpi;
	static 			xd,yd,xu,yu,xm,ym; // ߸ , 
	double			aa1,bb1,aa2,bb2;
	double static 	a1,b1,a2,b2;
    
	switch (msg) 
	{
		case WM_CREATE:
			 a1 = -2.1,  b1 = -1.5,	// z = -2.1-1.5i ~ 0.9+1.5i 
			 a2 =  0.9,  b2 =  1.5;	//   ׸
			 return 0;

		case WM_SIZE:
			 cpok = LOWORD(lParam);		// Ŭ̾Ʈ  
			 cnpi = HIWORD(lParam);		// 
			 return 0;
		
		case WM_LBUTTONDOWN:			//  ߸  
		     xd = LOWORD(lParam);		// 콺 Ŀ x ǥ    
		     yd = HIWORD(lParam);		//               y ǥ 
             return 0 ;

		case WM_MOUSEMOVE:				// 콺 ̵
			 hDC = GetDC(hWnd);
			 
			 if (wParam == MK_LBUTTON)	//  ߸ 
				{
				xm = LOWORD(lParam);    // 콺 Ŀ x ǥ    
				ym = HIWORD(lParam);	//               y ǥ 
             
				SetROP2(hDC, R2_NOT);	//  ׸  

				NeMo(hDC, xd,yd, xm,ym);// ׸ ׸ 

				Sleep(100); 			// 0.1 ʰ 
				NeMo(hDC, xd,yd, xm,ym);// ׸ 
				}
             ReleaseDC(hWnd, hDC);
			 return 0 ;

        case WM_LBUTTONUP:				//  ߸  
			 xu = LOWORD(lParam);		// 콺 Ŀ x ǥ    
		     yu = HIWORD(lParam);		//               y ǥ 
			 hDC = GetDC(hWnd);
			 SetROP2(hDC, R2_NOT);		//  ׸  

			 NeMo(hDC, xd,yd, xu,yu);	// ׸ ׸ 
			 SetROP2(hDC, R2_COPYPEN);	//  ׸ 
										//  ȯ
			 ReleaseDC(hWnd, hDC);
			 return 0 ;					

		case WM_RBUTTONDOWN: 
			 // 콺    a1,b1,a2,b2 Ѵ
			 aa1 = a1 + (a2-a1)*xd/cpok;
			 aa2 = a1 + (a2-a1)*xu/cpok;
			 bb1 = b1 + (b2-b1)*yd/cnpi;
			 bb2 = b1 + (b2-b1)*yu/cnpi;
             
			 a1 = aa1, b1=bb1;
			 a2 = aa2, b2=bb2;

			 // Ŭ̾Ʈ â  WM_PAINT ޽ ť 
			 InvalidateRect(hWnd, NULL,TRUE);
			 return 0;
		
		case WM_PAINT:
             hDC = BeginPaint (hWnd, &ps); 
			 
			 // z = a1+b1i ~ a2+b2i    ׸(BDM)
			 MdelSet(hWnd, a1,b1,a2,b2);
		
			 EndPaint( hWnd, &ps );		   
             return 0;

		case WM_DESTROY:                  
             PostQuitMessage(0);
             return 0;
		
		default:
			 return DefWindowProc(hWnd, msg, wParam, lParam);
    }
	return 0;
}
/*****************************************************************
* (x1,y1) ~ (x2,y2) ׸ 
*****************************************************************/
void NeMo(HDC hDC, int x1, int y1, int x2, int y2)
{
	MoveToEx(hDC, x1, y1, NULL);	// (x1, y1) ̵

	LineTo(hDC, x1,y2);				//  
	LineTo(hDC, x2,y2);				// Ʒ 
	LineTo(hDC, x2,y1);				//  
	LineTo(hDC, x1,y1);				//  
}
/****************************************************************
*  z = a1+b1i ~ a2+b2i    ׸
*****************************************************************/
#define	N		100					// ִ ݺ ȸ

void MdelSet(HWND hWnd, double a1, double b1, double a2, double b2)
{
	HDC		hDC = GetDC(hWnd);
	RECT	rt;
	double	x,y,x2,y2,c1,c2;
	int		i,j,k,s,cpok, cnpi;	
	long	saek[8] = { RGB(0,  0,  0),   RGB(255,0,  0), 
						RGB(0,  255,0),   RGB(0,  0,  255), 
						RGB(255,255,0),   RGB(255,0,  255),
						RGB(0,  255,255), RGB(255,255,255) };	
	GetClientRect(hWnd, &rt);
	cpok = rt.right;					// Ŭ̾Ʈ  
	cnpi = rt.bottom;					// Ŭ̾Ʈ  

	// Ŭ̾Ʈ     ݺ		
	for (i=0 ; i<=cnpi ; i++)				
	{
		for (j=0 ; j<=cpok ; j++)
		{
			c1 = (a2 - a1)*j/cpok + a1;	// z = x+yi Ǽ(x)
			c2 = (b2 - b1)*i/cnpi + b1;	// (y) 
			 
			x = y = 0;					// z = 0+0i  
			for (k=0 ; k<N ; k++)
			{
				x2 = x*x - y*y +c1;		// z2+c 
				y2 = 2*x*y + c2;
				x  = x2;				// z2+c -> z Ѵ
				y  = y2;
		      	  
				if (x*x+y*y > 10000)	// ߻ 
		      		break; 				// k for 
			}
			x = 10*sin(x);
		 	if      (k==N)   s = (unsigned)x%6+1; //տ ϸ
			else if (k>=N/2) s = 7;		//  α̸ Ͼ
			else if (y>0)    s = k%6+1;	//  ̸ 
			else			 s = 0;

			SetPixel(hDC, j, i, saek[s]);
			GetAsyncKeyState(VK_LBUTTON);	 
		}		
	}
}  