#include "init.h"		// InitApp(),InitInst()
#include "jumsun.h"		// JumSunGraph(), JUM, SUN

void	GetCos(double *, short);
//***************************************************************
int PASCAL WinMain(HINSTANCE hInstance,	HINSTANCE hPrevInstance, 
				   LPSTR	 lpCmdLine,	int		  nCmdShow     )
{	MSG	msg;

	InitApp( hInstance, "SHGRAPH");			
	InitInst(hInstance, nCmdShow,	"SHGRAPH", 
									"y = cos(10x)cos(x) ׷");
	// ޽ Ͽ WndProc() 	  
	while (GetMessage(&msg, NULL, 0, 0))  
	{
		TranslateMessage(&msg);				// Űڵ ȯѴ
		DispatchMessage(&msg);				// ޽ 
	}
	return (msg.wParam); 
}
//******************************************************************
LRESULT WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	short		cPok, xk;
	HDC			hdc ;		
	double		a[1000];
	
	switch (msg)
	{
		case WM_SIZE:
			 cPok  = LOWORD(lParam);			// Ŭ̾Ʈ
			 hdc   = GetDC(hWnd);
			 xk	   = cPok*0.9;					// x 	 

			 // x : 0 ~ xk   cos(10x)cos(x)  -> a[]
			 GetCos(a, xk);	
			 
			 // a[](cos(10x)cos(x)) + ׷ ׸
			 JumSunGraph(hWnd, a, xk,			// 迭, 迭Ҽ
						 2, 					// y   
						 1, 					// y  ġ	
						 JUM+SUN);				// ׷ 
			 ReleaseDC(hWnd, hdc);			
			 return 0 ;		
		case WM_DESTROY:        
			 PostQuitMessage(0);	break;
		default:
    		 return DefWindowProc(hWnd, msg, wParam, lParam);
    }
    return 0;
}					 
//****************************************************************
// x : 0 ~ 2PI   cos(10*x)*cos(x)  -> a[]
//****************************************************************
#define  PI		3.14159

void GetCos(double a[], short pok)
{	
	for (int i=0 ; i<pok ; i++)
	{
		double x = (double)i/pok * (2*PI); //  x : 0~2PI
		
		a[i] = cos(10*x)*cos(x);
	}
}
